unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeComma, ExtCtrls, TeeProcs, TeEngine, Chart, StdCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    BFirst: TButton;
    BPred: TButton;
    BNext: TButton;
    BLast: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BFirstClick(Sender: TObject);
    procedure BPredClick(Sender: TObject);
    procedure BNextClick(Sender: TObject);
    procedure BLastClick(Sender: TObject);
  private
    { Private declarations }
    procedure SetAxisDate(date: TDateTime);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses GanttCh, DateUtils, Series;

procedure TForm1.FormCreate(Sender: TObject);
var i, j: Integer;
    tmpDate, tmpSDate, tmpEDate: TDateTime;
begin
  Chart1.View3D:=false;
  Chart1.Legend.Visible:=false;
  Chart1.Axes.Left.MinimumOffset:=25;
  Chart1.Axes.Left.MaximumOffset:=25;

  tmpDate:=Today;
  ReplaceTime(tmpDate, EncodeTime(7,0,0,0));
  with Chart1.AddSeries(TGanttSeries) as TGanttSeries do
  begin
    Pointer.VertSize:=10;
    Marks.Visible:=true;
    XValues.Order:=loNone;

    j:=0;
    for i:=0 to 5*100-1 do
    begin
      tmpSDate:=IncHour(tmpDate, Round(random*9));
      tmpEDate:=IncHour(tmpSDate, Round(random*(17-HourOf(tmpSDate)-1)+1));

      AddGantt(tmpSDate, tmpEDate, j, 'job ' + IntToStr(j+1));
      Inc(j);

      if (i+1) mod 5 = 0 then
      begin
        tmpDate:=IncDay(tmpDate);
        if DayOfWeek(tmpDate) = 7 then //Saturday
          tmpDate:=IncDay(tmpDate, 2);

        j:=0;
      end;
    end;
  end;

  SetAxisDate(Today);
end;

procedure TForm1.BFirstClick(Sender: TObject);
begin
  SetAxisDate(Chart1[0].XValues.MinValue);
end;

procedure TForm1.BPredClick(Sender: TObject);
begin
  if (DayOfWeek(Chart1.Axes.Bottom.Minimum-1) = 1) then //Sunday
  begin
    if ((Chart1.Axes.Bottom.Minimum-3) > Chart1[0].XValues.MinValue) then
      SetAxisDate(IncDay(Chart1.Axes.Bottom.Minimum, -3));
  end
  else
    if (Chart1.Axes.Bottom.Minimum-1) > Chart1[0].XValues.MinValue then
      SetAxisDate(IncDay(Chart1.Axes.Bottom.Minimum, -1));
end;

procedure TForm1.BNextClick(Sender: TObject);
begin
  if (DayOfWeek(Chart1.Axes.Bottom.Minimum+1) = 7) then //Saturday
  begin
    if ((Chart1.Axes.Bottom.Minimum+3) > Chart1[0].XValues.MinValue) then
      SetAxisDate(IncDay(Chart1.Axes.Bottom.Minimum, 3));
  end
  else
  if (Chart1.Axes.Bottom.Minimum+1) < Chart1[0].XValues.MaxValue then
    SetAxisDate(IncDay(Chart1.Axes.Bottom.Minimum));
end;

procedure TForm1.BLastClick(Sender: TObject);
begin
  SetAxisDate(Chart1[0].XValues.MaxValue);
end;

procedure TForm1.SetAxisDate(date: TDateTime);
var min, max: TDateTime;
begin
  max:=date;
  ReplaceTime(max, EncodeTime(17,0,0,0));
  min:=date;
  ReplaceTime(min, EncodeTime(7,0,0,0));

  Chart1.Axes.Bottom.SetMinMax(min, max);


  Chart1.Title.Text.Text:=LongDayNames[DayOfTheWeek(date)+1] + ' ' + DateToStr(date);
end;

end.
